import {IEvent, Object} from 'fabric/fabric-impl'
import {fabric} from 'fabric'

export enum ObjectType {
    Unknown = 'unknown',
    Rectangle = 'rect',
}

export enum ZoneType {
    Rect,
}

export type DrawRectangle = {
    color?: string;
    isRotatable?: boolean;
}

export type BaseObject = DataRectangle & Object

export type DataRectangle = {
    angle: number;
    color: string;
    data: any;
    height: number;
    isRotatable?: boolean;
    label?: string;
    left: number;
    top: number;
    width: number;
    uid: string;
}

export type SelectionIEvent = IEvent & {
    selected: Object[];
}

export interface Rectangle extends BaseObject {
    type: ObjectType.Rectangle;
}

export interface LabeledRect extends fabric.Rect {
    label: string;
    type: 'rect';
    uid: string;
    restoreLabel: () => void;
}
